﻿using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using PoGo.NecroBot.Logic.Common;
using PoGo.NecroBot.Logic.Logging;
using PoGo.NecroBot.Logic.State;

namespace PoGo.NecroBot.Logic.Tasks
{
    public class GetPokeDexCount
    {
        public static async Task Execute(ISession session, CancellationToken cancellationToken)
        {
            cancellationToken.ThrowIfCancellationRequested();

            //await session.Inventory.RefreshCachedInventory().ConfigureAwait(false);

            var PokeDex = await session.Inventory.GetPokeDexItems().ConfigureAwait(false);
            var _totalUniqueEncounters = PokeDex.Select(
                i => new
                {
                    Pokemon = i.InventoryItemData.PokedexEntry.PokemonId,
                    Captures = i.InventoryItemData.PokedexEntry.TimesCaptured
                }
            );
            var _totalCaptures = _totalUniqueEncounters.Count(i => i.Captures > 0);
            var _totalData = PokeDex.Count();

            Logger.Write(session.Translation
                .GetTranslation(TranslationString.AmountPkmSeenCaught, _totalData, 252, _totalCaptures, 252)
            );
        }
    }
}